/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this tstlate file, choose Tools | Tstlates
 * and open the tstlate in the editor.
 */
package exemplu_jaxb;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author claudiu
 */
public class Exemplu_JAXB {

    /**
     * @param args the command line arguments
     */
 
    public static void main(String[] args) throws JAXBException 
    {
        Map<String, Student> map = new HashMap<String, Student>();

        Student st1 = new Student();
        st1.setNume("Ion Apetrei");
        st1.setCNP("1701123132456");
        st1.setGrupa(1040);
        st1.setNotaPOO(9);
        st1.setNotaPAW(8);
        st1.setNotaJava(4);

        Student st2 = new Student();
        st2.setNume("George Grigorescu");
        st2.setCNP("1861123322456");
        st2.setGrupa(1020);
        st2.setNotaPOO(5);
        st2.setNotaPAW(6);
        st2.setNotaJava(5);

        map.put(st1.getCNP(), st1);
        map.put(st2.getCNP(), st2);

        //Add student in map
        StudentMap studentMap = new StudentMap();
        studentMap.setStudentMap(map);

        // Marshalling
  
        JAXBContext jaxbContext = JAXBContext.newInstance(StudentMap.class);
        Marshaller jaxbMarshaller = jaxbContext.createMarshaller();

        jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);

        jaxbMarshaller.marshal(studentMap, System.out);
        jaxbMarshaller.marshal(studentMap, new File("C:/Users/claudiu/Documents/ASE/Docs/Java/Exemplu_JAXB/students.xml"));

        System.out.println("############################################################################");

        // Demarshalling 
 
        jaxbContext = JAXBContext.newInstance(StudentMap.class);
        Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
        StudentMap stMap = (StudentMap) jaxbUnmarshaller.unmarshal( new File("C:/Users/claudiu/Documents/ASE/Docs/Java/Exemplu_JAXB/students.xml") );

        for(String stId : stMap.getStudentMap().keySet())
        {
                System.out.println(stMap.getStudentMap().get(stId).toString());
        }
    }
}

